<!--
    Adelmo De Santis - PHP code to display rtl_433 sensors data
    Copyright (C) 2019 Adelmo De Santis

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

-->



<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it" lang="it">
<head>
        <meta http-equiv="Content-Type" content="text/html;charset=ISO-8859-1" />
        <meta name="google-site-verification" content="xiguy5EDdJihJ5jE2VPUxPeQxLHsSoLUyMxIOwwmYUM" />
        <META NAME="Description" CONTENT="Sensori Remoti">
        <title>Meteo Casa Polverigi </title>

        <style type="text/css" media="screen">
                body{font: 100% Arial, Helvetica, sans-serif}

                h1{font-size: 2.4em}
                h3{font-size: 1.4em}
        </style>
</head>


<body>

<h3>Informazioni sui sensori remoti</h3>

<?php
require_once 'mobile/Mobile_Detect.php';
$detect = new Mobile_Detect;

$mobile=0;

//Codifica di mobile
// 1 mobile
// 2 android
// 3 IOS

if ( $detect->isMobile() ) {
$mobile=1; 
}

if( $detect->isAndroidOS() ){
$mobile=2; 
}

//http://mobiledetect.net/	
	
$conn=mysqli_connect("localhost","username","password");
        if (!$conn)
                die("Connection Failure");
        if (!(mysqli_select_db($conn,"weather")))
                die("Cannot Change Database");


//Query dei dati sensore soffitta  8 righe
//select distinct(sensore) from remotesensors_temp order by ts asc
$distinct_sensors=mysqli_query($conn,"select sensore,unix_timestamp(max(ts)) from remotesensors_temp where sensore IN (select distinct(sensore) from remotesensors_temp) group by sensore;");
while($distinct_sensors_data=mysqli_fetch_array($distinct_sensors)){
    $sensore[] = $distinct_sensors_data['sensore'];
	$ts[] = $distinct_sensors_data['unix_timestamp(max(ts))'];
}

$ssize=count($sensore);
$tsize=count($ts);

$data=array_combine($sensore,$ts);

$dsize=count($data);

//echo "Dimensioni $ssize $tsize $dsize";


//array_multisort($sensore, SORT_ASC, $ts, SORT_DESC, $data);
arsort($data);
//echo "<br>";

//foreach ($data as $key => $val) {
//    echo "$key = $val\n";
//	echo "<br>";
//}

$dsize=count($data);
//echo "Dimensioni dopo sort $dsize";

date_default_timezone_set('Europe/Rome');
$timestamp=time(); //get current time

$cur_year=date('Y',$timestamp);
$cur_mont=date('m',$timestamp);
$cur_day=date('d',$timestamp);

echo "<table width=\"75%\" border=\"1\" align=\"center\"> \n";
echo "<tr> \n";
echo "<td align=\"center\" colspan=\"17\"> <b>Sensori Remoti</b> </td> \n";
echo "</tr>\n";
echo "<tr> \n" ;
echo "<td align=\"center\"> Sensore </td> \n";
echo "<td align=\"center\"> Ora e data </td> \n";
echo "<td align=\"center\"> Temperatura </td> \n";
echo "<td align=\"center\"> Umidita </td> \n";
echo "<td align=\"center\"> Pressione </td> \n";
echo "<td align=\"center\"> Dewpoint </td> \n";
echo "<td align=\"center\"> Direzione </td> \n";
echo "<td align=\"center\"> Velocita </td> \n";
echo "<td align=\"center\"> Raffica </td> \n";
echo "<td align=\"center\"> Pioggia </td> \n";
echo "<td align=\"center\"> RSSI </td> \n";
echo "<td align=\"center\"> SNR </td> \n";
echo "<td align=\"center\"> Noise </td> \n";
echo "<td align=\"center\"> Freq </td> \n";
echo "<td align=\"center\"> Campioni </td> \n";
echo "<td align=\"center\"> 1 day </td> \n";
echo "<td align=\"center\"> 7 days </td> \n";
echo "</tr> \n";

$sensore=array_keys($data);
$ssize=count($sensore);

//echo "<br>";

//foreach ($sensore as $key => $val) {
//    echo "$key = $val\n";
//	echo "<br>";
//}


foreach($sensore as $key => $n){
	$data_sensor=mysqli_query($conn,"select * from remotesensors_temp where sensore='$n' order by ts desc limit 1");
		$data_sensore=mysqli_fetch_array($data_sensor);
		$sensore_nome=substr($data_sensore["sensore"],0,30);
		$sensore_tempo=$data_sensore["ts"];
		$sensore_temperatura=$data_sensore["temperatura"];
		$sensore_umidita=$data_sensore["umidita"];
		$sensore_pressione=$data_sensore["pressione"];
		$sensore_dewpoint=$data_sensore["dewpoint"];
		$sensore_direzione=$data_sensore["direzione"];
		$sensore_velocita=$data_sensore["velocita"];
		$sensore_gust=$data_sensore["massimo"];
		$sensore_pioggia=$data_sensore["pioggia"];
		$sensore_rssi=$data_sensore["rssi"];
		$sensore_snr=$data_sensore["snr"];
		$sensore_noise=$data_sensore["noise"];
		$sensore_freq=$data_sensore["freq"];
	$data_number=mysqli_query($conn,"select count(*) from remotesensors_temp where sensore='$n' ");	
		$data_number_result=mysqli_fetch_array($data_number);
		$numero=$data_number_result["count(*)"];
		echo "<tr> \n" ;
		echo "<td align=\"center\"> $sensore_nome </td> \n";
		echo "<td align=\"center\"> $sensore_tempo </td> \n";
		echo "<td align=\"center\"> $sensore_temperatura </td> \n";
		echo "<td align=\"center\"> $sensore_umidita </td> \n";
		echo "<td align=\"center\"> $sensore_pressione </td> \n";
		echo "<td align=\"center\"> $sensore_dewpoint </td> \n";
		echo "<td align=\"center\"> $sensore_direzione </td> \n";
		echo "<td align=\"center\"> $sensore_velocita </td> \n";
		echo "<td align=\"center\"> $sensore_gust </td> \n";
		echo "<td align=\"center\"> $sensore_pioggia</td> \n";
		echo "<td align=\"center\"> $sensore_rssi</td> \n";
		echo "<td align=\"center\"> $sensore_snr </td> \n";
		echo "<td align=\"center\"> $sensore_noise </td> \n";
		echo "<td align=\"center\"> $sensore_freq 	</td> \n";
		echo "<td align=\"center\"> $numero  	</td> \n";
		echo "<td> \n";
		echo "<form action=\"dettagli_remote.php\"> \n";
		echo "<input type=\"hidden\" name=\"span\"  value=1  /> \n";
		echo "<input type=\"hidden\" name=\"sens\"  value=$sensore_nome  /> \n";
		echo "<input type=\"hidden\" name=\"year\"  value=$cur_year /> \n"; 
        echo "<input type=\"hidden\" name=\"month\" value=$cur_mont  /> \n";
    	echo "<input type=\"hidden\" name=\"day\"   value=$cur_day   /> \n";
		echo "<input type=\"hidden\" name=\"mobile\"  value=$mobile  /> \n";
		//echo "</fieldset> \n";
		echo "<input type=\"submit\"> \n";
		echo "</form> \n";
		echo "</td> \n";
		echo "<td> \n";
		echo "<form action=\"dettagli_remote.php\"> \n";
   		//echo "<fieldset> \n";
		echo "<input type=\"hidden\" name=\"span\"  value=7  /> \n";
		echo "<input type=\"hidden\" name=\"sens\"  value=$sensore_nome  /> \n";
		echo "<input type=\"hidden\" name=\"year\"  value=$cur_year  /> \n"; 
        echo "<input type=\"hidden\" name=\"month\" value=$cur_mont  /> \n";
    	echo "<input type=\"hidden\" name=\"day\"   value=$cur_day   /> \n";
		echo "<input type=\"hidden\" name=\"mobile\"  value=$mobile  /> \n";
		//echo "</fieldset> \n";
		echo "<input type=\"submit\"> \n";
		echo "</form> \n";
		echo "</td> \n";
}
echo "</table>\n";

mysqli_close($conn);	


//prendo lo stato della tensione e delle finestre con MOR.

?>
<br><br>
<p align="center">Alcune informazioni sui sensori ricevuti. Il codice sergenti opera di Benjamin Larsson https://github.com/merbanan</p>
<table width="75%" border="1" align="center">
	<tr>
		<td> Nome</td>
		<td> Tipologia</td>
		<td> Source File </td>
		<td> Informazioni</td>
	</tr>
	<tr>
		<td> OSv1_Temperature_Sensor</td>
		<td> Sensore temperatura</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/oregon_scientific_v1.c"> Sorgente </a> </td>
		<td> Dato: temperature_C</td>
	</tr>
	<tr>
		<td> Fine_Offset_Electronics_WH1080 </td>
		<td> Sensore misto</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/fineoffset_wh1080.c"> Sorgente </a> </td></td>
		<td> Dato: temperature_C - humidity - direction_str - direction_deg - speed - gust</td>
	</tr>
	<tr>
		<td> THN132N </td>
		<td> Oregon Scientific</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/oregon_scientific_sl109h.c"> Sorgente </a> </td></td>
		<td> Dato: temperature_C</td>
	</tr>
	<tr>
		<td> Citroen </td>
		<td> Sensore TPMS</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/tpms_citroen.c"> Sorgente </a> </td>
		<td> Dato: temperature_C - pressure_kPa</td>
	</tr>
	<tr>
		<td> Ford </td>
		<td> Telecomando</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/fordremote.c"> Sorgente </a></td>
		<td> </td>
	</tr>
	<tr>
		<td> Toyota </td>
		<td> Sensore TPMS</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/tpms_toyota.c"> Sorgente </a></td>
		<td> Dato: pressure_PSI - temperature_C</td>
	</tr>
	<tr>
		<td> Schrader </td>
		<td> Sensore TPMS</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/schraeder.c"> Sorgente </a></td>
		<td> Dato: pressure_bar - temperature_C</td>
	</tr>
	<tr>
		<td> Renault </td>
		<td> Sensore TPMS</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/tpms_renault.c"> Sorgente </a></td>
		<td> Dato: pressure_kpa - temperature_C</td>
	</tr>
	<tr>
		<td> Efergy_e2_CT </td>
		<td> Sensore elettrico</td>
		<td> <a href=" "> Sorgente </a> </td>
		<td> </td>
	</tr>
	<tr>
		<td> Oregon_Scientific_SL109H </td>
		<td> Sensore meteo</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/oregon_scientific_sl109h.c"> Sorgente </a> </td>
		<td> Dato: temperature_C - humidity</td>
	</tr>
	<tr>
		<td> THR228N </td>
		<td> Oregon Scientific Temperatura</Oregon>/td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/oregon_scientific_sl109h.c"> Sorgente </a> </td>
		<td> Dato: temperature_C - humidity</td>
	</tr>
	<tr> 
		<td> Interlogix </td>
		<td> General Electric, vari sensori.</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/interlogix.c"> Sorgente </a> </td>
		<td> </td>
	</tr>
	<tr>
		<td> Acurite_986_Sensor </td>
		<td> Sensore temperatura</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/acurite.c"> Sorgente </a> </td>
		<td> Dato: temperature_C - humidity - water </td>
	</tr>
	<tr>
		<td> Generic_motion_sensor </td>
		<td> Sensori generici e per allarme</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/generic_motion.c"> Sorgente </a> </td>
		<td>  </td>
	</tr>
	<tr>
		<td> Honda Remote </td>
		<td> Telecomando</td>
		<td> <a href="https://github.com/merbanan/rtl_433/blob/master/src/devices/hondaremote.c"> Sorgente </a> </td>
		<td>  </td>
	</tr>
</table>

</body>
</html>

